/*
 * Project: irond
 * Package: src.de.fhhannover.inform.iron.mapserver.communication
 * File:    Usermanager.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.iron.mapserver.communication;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Properties;

import org.apache.log4j.Logger;

import de.fhhannover.inform.iron.mapserver.logging.Logging;

public class Usermanager extends Properties {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static Usermanager mConfReader;
	private HashMap<String, Client> mRelation = new HashMap<String,Client>();
	private static final String PROP_PATH = "user.properties";
	private static Logger logger;
	static {
		logger = Logging.getTheLogger();
	}
	
	public static Usermanager getInstance() {
		if (mConfReader == null) {
			mConfReader = new Usermanager();
		}
		return mConfReader;
	}
	
	private Usermanager() {
		try {
			System.out.println(System.getProperty("user.dir"));
			FileReader mPropFile = new FileReader(PROP_PATH);
			this.load(mPropFile);
			mPropFile.close();
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public boolean checkBasicAuth(String name, String pass) {
		String passFile = getProperty(name);
		if(pass.equals(passFile)) {
			logger.info("Accepted basic client " + name);
			return true;
		} else {
			logger.info("Rejected basic client " + name);
			return false;
		}
	}
	
	public synchronized Client getClient (String username){
		Client client;
		if ( (client =mRelation.get(username)) != null){
			return client;
		}else{
			return null;
		}
	}
	
	public synchronized boolean addClient (String user, String pw, Client client){
		return true;
	}
	
	public synchronized void addClient (String dn, Client client){

	}
}
