/*
 * Project: irond
 * Package: src.de.fhhannover.inform.iron.mapserver.communication.services.ssrc
 * File:    SubscribeObserverConnection.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.iron.mapserver.communication.services.ssrc;


import java.security.NoSuchAlgorithmException;

import de.fhhannover.inform.iron.mapserver.communication.connections.ConnectionContainer;
import de.fhhannover.inform.iron.mapserver.communication.connections.SSRC;
import de.fhhannover.inform.iron.mapserver.communication.services.ssrc.exceptions.SessionNotFoundException;
import de.fhhannover.inform.iron.mapserver.datamodel.SubscriptionObserver;

/*
 *  15.06.10 aw - removed non implemented endSessionPollResult()
 */

public class SubscribeObserverConnection implements SubscriptionObserver {

	@Override
	public void pollResultAvailable(String sessionId) {		
		SSRC ssrc;
		try {
			ssrc = ConnectionContainer.getInstance().getSessionBySessionID(sessionId);
			if (ssrc.isWaitingForPollResult()) {
				ssrc.sendPollResponse();
			} else {
				ssrc.setPollResultAvailable();
			}
		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SessionNotFoundException e) {
			//Nothing to do
		}
	}
}
