/*
 * Project: irond
 * Package: src.de.fhhannover.inform.iron.mapserver.configuration
 * File:    ConfigurationReader.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.iron.mapserver.configuration;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.Properties;

public class ConfigurationReader extends Properties {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static ConfigurationReader mConfReader;
	// private static final String PROP_PATH = "../conf/ifmap.properties" ;
	private static final String PROP_PATH = "ifmap.properties";

	private ConfigurationReader() {

		try {
			System.out.println(System.getProperty("user.dir"));
			FileReader mPropFile = new FileReader(PROP_PATH);
			this.load(mPropFile);
			mPropFile.close();

		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static ConfigurationReader getInstance() {
		if (mConfReader == null) {
			mConfReader = new ConfigurationReader();
		}
		return mConfReader;
	}

	public void put(String key, String value, String comment) {

		super.put(key, value);
		try {
			FileOutputStream fos = new FileOutputStream(PROP_PATH);
			this.store(fos, comment);
			fos.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.err.println("ifmap.properties nicht erreichbar");
			e.printStackTrace();
		}
	}

	public void put(String key, String value) {
		super.put(key, value);
		try {
			FileOutputStream fos = new FileOutputStream(PROP_PATH);
			this.store(fos, "no comment");
			fos.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.err.println("ifmap.properties nicht erreichbar");
			e.printStackTrace();
		}
	}

}
